HTTPS SSH

WP Helper Logo

License: LGPL v3

WP Helper

WP Helper is a library of functions that theme and plug-in developers can use to provide a consistent experience to their users, by abstracting as much of the standard WordPress functionality, hooks and settings as possible - resulting in a much simpler and less time-consuming way to develop with WordPress (current WordPress target version is 4.9.2).

WP Helper helps developers to stop worrying about WordPress-specific implementation details and gotchas - and to get on with the business of building something awesome!

WP Helper can function as:

  • an included PHP library (as part of a theme or plug-in that is installed),
  • or as an installed plug-in itself (which can conveniently be updated via WordPress' update mechanism).

Features

  • Front-end WordPress API method and hook wrappers
  • Back-end WordPress API method and hook wrappers (including rapid UI development)
  • Supports MVC or the MVVMC methodologies
  • Database and file logging; along with log viewer (if back-end tools UI is enabled)
  • WordPress options editor (if back-end tools UI is enabled)
  • WP_DEBUG indicator (in the back-end)

Getting Started

As an included library, with Composer:

Make sure Composer is installed - if not, you can get it from here.

First, you need to add WP Helper as a dependency in your composer.json file.

To use the current stable version, add the following to download it straight from here:

PLEASE NOTE! There is currently no stable version available, WP Helper is still under development until version 1.0.0 - this is here for future reference (currently use "ion/wp-helper": "dev-default" instead)

"require": {
    "php": ">=7.0",
    "ion/wp-helper": "^1.*",
}

To use the bleeding edge (development) version, add the following:

"require": {
    "php": ">=7.1",
    "ion/wp-helper": "dev-default", 
},
"repositories": {
    {
      "type": "vcs",
      "url": "https://bitbucket.org/wpsolved/wp-helper/"
    }
}

Then run the following in the root directory of your project:

php composer.phar install

As a WordPress plugin (using wordpress.org):

PLEASE NOTE! There is currently no stable version available, WP Helper is still under development until version 1.0.0 - this is here for future reference.

Simply log into your WordPress installation, navigate to:

Plugins > Add new

Then search for 'WP Helper' and install as you would any other plugin.

As a WordPress plugin (using manual upload):

Download a packaged version (in .ZIP format), here

Log into your WordPress installation and navigate to:

Plugins > Add new > Upload Plugin

Then select the .ZIP and upload.

As an included library, without Composer:

Download a packaged version (in .ZIP format), here

Unzip the package and make sure you include 'include.php,' like so (assuming you unzipped the package into the relative path 'includes/wp-helper'):

require_once( __DIR__ . '/includes/wp-helper/include.php' ); 

Prerequisites

  • WordPress
  • Composer (optional)

Built With

  • Composer - Dependency Management
  • Phing - Used to generate custom builds for various target PHP versions (5.6, 7.0, 7.1)
  • NetBeans - IDE
  • PHP Storm - IDE

Versioning

We use SemVer for versioning. For the versions available, see the tags on this repository.

Authors

License

This project is licensed under the LGPL-3.0 License - see the LICENSE.md file for details.